import { objectWithoutProperties as _objectWithoutProperties, slicedToArray as _slicedToArray, extends as _extends } from '../../../_virtual/_rollupPluginBabelHelpers.js';
import React, { forwardRef, useState } from 'react';
import { DropdownUncontrolled } from './DropdownUncontrolled.js';

var _excluded = ["closeOnSelect", "onToggle", "onItemClick", "onItemSelect"];
var Dropdown = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _ref$closeOnSelect = _ref.closeOnSelect,
    closeOnSelect = _ref$closeOnSelect === void 0 ? true : _ref$closeOnSelect,
    onToggle = _ref.onToggle,
    onItemClick = _ref.onItemClick,
    onItemSelect = _ref.onItemSelect,
    rest = _objectWithoutProperties(_ref, _excluded);
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isOpen = _useState2[0],
    setIsOpen = _useState2[1];
  var handleToggle = function handleToggle(currentState, event) {
    setIsOpen(currentState);
    if (onToggle) {
      onToggle(currentState, event);
    }
  };
  var handleClick = function handleClick(item, event) {
    if (onItemClick) {
      onItemClick(item, event);
    }
    if (onItemSelect) {
      onItemSelect(item, event);
    }
    if (closeOnSelect) {
      setIsOpen(false);
    }
  };
  return /*#__PURE__*/React.createElement(DropdownUncontrolled, _extends({}, rest, {
    ref: ref,
    isOpen: isOpen,
    onToggle: handleToggle,
    closeOnSelect: closeOnSelect,
    handleClick: handleClick,
    onGlobalClose: function onGlobalClose() {
      return setIsOpen(false);
    }
  }));
});

export { Dropdown };
//# sourceMappingURL=Dropdown.js.map
