var _excluded = ["children", "isOpen", "trigger", "placement", "disabled", "closeOnSelect", "onToggle", "onItemClick", "onItemSelect", "listOverflow", "listHeight", "items", "itemRole", "onHover", "handleClick", "onGlobalClose"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useState, forwardRef } from 'react';
import { dropdownConfig, dropdownItemConfig, component, mergeConfig } from '@salutejs/plasma-new-hope/styled-components';
import styled from 'styled-components';
import { IconDisclosureRight } from '@salutejs/plasma-icons';
import { config } from '../Dropdown.config';
var mergedConfig = /*#__PURE__*/mergeConfig(dropdownConfig, config);
var DropdownNewHope = /*#__PURE__*/component(mergedConfig);
var mergedItemConfig = /*#__PURE__*/mergeConfig(dropdownItemConfig);
export var DropdownNewHopeItem = /*#__PURE__*/component(mergedItemConfig);
var DropdownWrapper = /*#__PURE__*/styled.div.withConfig({
  componentId: "plasma-web__sc-1k01myq-0"
})(["& .popover-wrapper,& .popover-target{display:block;}& .popover-root{height:", ";overflow:", ";}"], function (_ref) {
  var listHeight = _ref.listHeight;
  return !Number.isNaN(Number(listHeight)) ? "".concat(listHeight, "rem") : listHeight;
}, function (_ref2) {
  var listOverflow = _ref2.listOverflow;
  return listOverflow;
});
var StyledContent = /*#__PURE__*/styled.div.withConfig({
  componentId: "plasma-web__sc-1k01myq-1"
})(["display:inline-flex;margin-right:0.375rem;"]);
var DropdownItem = function DropdownItem(_ref3) {
  var item = _ref3.item,
    index = _ref3.index,
    itemRole = _ref3.itemRole,
    onClick = _ref3.handleClick,
    handleOnHover = _ref3.handleOnHover,
    contentRight = _ref3.contentRight;
  var handleClick = function handleClick(e) {
    if (onClick) {
      onClick(item, e);
    }
  };
  var handleMouseOver = function handleMouseOver() {
    return handleOnHover(index);
  };
  return (
    /*#__PURE__*/
    // eslint-disable-next-line jsx-a11y/mouse-events-have-key-events
    React.createElement(DropdownNewHopeItem, {
      key: item.value,
      value: item.value,
      onClick: handleClick,
      onMouseOver: handleMouseOver,
      role: itemRole,
      disabled: item.isDisabled,
      contentLeft: /*#__PURE__*/React.createElement(StyledContent, null, item.contentLeft),
      contentRight: contentRight,
      text: item.label,
      style: {
        color: item.color
      }
    })
  );
};
var DropdownInner = function DropdownInner(_ref4) {
  var children = _ref4.children,
    _ref4$closeOnSelect = _ref4.closeOnSelect,
    closeOnSelect = _ref4$closeOnSelect === void 0 ? true : _ref4$closeOnSelect,
    onItemClick = _ref4.onItemClick,
    onItemSelect = _ref4.onItemSelect,
    items = _ref4.items,
    itemRole = _ref4.itemRole,
    onHover = _ref4.onHover,
    onGlobalClose = _ref4.onGlobalClose;
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isOpen = _useState2[0],
    setIsOpen = _useState2[1];
  var handleToggle = function handleToggle(currentState, _) {
    setIsOpen(currentState);
  };
  var handleOnHover = function handleOnHover(index) {
    if (onHover) {
      onHover(index);
    }
  };
  var handleClick = function handleClick(item, event) {
    if (onItemClick) {
      onItemClick(item, event);
    }
    if (onItemSelect) {
      onItemSelect(item, event);
    }
    if (closeOnSelect && onGlobalClose) {
      onGlobalClose();
    }
  };
  return /*#__PURE__*/React.createElement(DropdownNewHope, {
    target: children,
    isOpen: isOpen,
    onToggle: handleToggle,
    trigger: "hover",
    placement: "right",
    offset: [0, 0]
  }, items.map(function (item, index) {
    return item.items ? /*#__PURE__*/React.createElement(DropdownInner, {
      key: index,
      items: item.items,
      role: itemRole,
      closeOnSelect: closeOnSelect,
      onItemClick: onItemClick,
      onItemSelect: onItemSelect,
      onHover: onHover,
      onGlobalClose: onGlobalClose
    }, /*#__PURE__*/React.createElement(DropdownItem, {
      item: item,
      index: index,
      itemRole: itemRole,
      handleOnHover: handleOnHover,
      handleClick: handleClick,
      contentRight: IconDisclosureRight
    })) : /*#__PURE__*/React.createElement(DropdownItem, {
      key: index,
      item: item,
      index: index,
      itemRole: itemRole,
      handleOnHover: handleOnHover,
      handleClick: handleClick
    });
  }));
};
export var DropdownUncontrolled = /*#__PURE__*/forwardRef(function (_ref5, ref) {
  var children = _ref5.children,
    isOpen = _ref5.isOpen,
    trigger = _ref5.trigger,
    _ref5$placement = _ref5.placement,
    placement = _ref5$placement === void 0 ? 'bottom' : _ref5$placement,
    disabled = _ref5.disabled,
    _ref5$closeOnSelect = _ref5.closeOnSelect,
    closeOnSelect = _ref5$closeOnSelect === void 0 ? true : _ref5$closeOnSelect,
    onToggle = _ref5.onToggle,
    onItemClick = _ref5.onItemClick,
    onItemSelect = _ref5.onItemSelect,
    listOverflow = _ref5.listOverflow,
    listHeight = _ref5.listHeight,
    items = _ref5.items,
    itemRole = _ref5.itemRole,
    onHover = _ref5.onHover,
    handleClick = _ref5.handleClick,
    onGlobalClose = _ref5.onGlobalClose,
    rest = _objectWithoutProperties(_ref5, _excluded);
  var handleOnHover = function handleOnHover(index) {
    if (onHover) {
      onHover(index);
    }
  };
  return /*#__PURE__*/React.createElement(DropdownWrapper, {
    listHeight: listHeight,
    listOverflow: listOverflow
  }, /*#__PURE__*/React.createElement(DropdownNewHope, _extends({}, rest, {
    ref: ref,
    target: children,
    isOpen: isOpen,
    onToggle: onToggle,
    trigger: trigger,
    placement: placement,
    offset: [0, 0],
    closeOnOverlayClick: true
  }), !disabled && items.map(function (item, index) {
    return item.items ? /*#__PURE__*/React.createElement(DropdownInner, {
      key: index,
      items: item.items,
      itemRole: itemRole,
      closeOnSelect: closeOnSelect,
      onItemClick: onItemClick,
      onItemSelect: onItemSelect,
      onHover: onHover,
      onGlobalClose: onGlobalClose
    }, /*#__PURE__*/React.createElement(DropdownItem, {
      item: item,
      index: index,
      itemRole: itemRole,
      handleOnHover: handleOnHover,
      handleClick: handleClick,
      contentRight: IconDisclosureRight
    })) : /*#__PURE__*/React.createElement(DropdownItem, {
      key: index,
      item: item,
      index: index,
      itemRole: itemRole,
      handleOnHover: handleOnHover,
      handleClick: handleClick
    });
  })));
});